/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the MessageOrderDetails type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MessageOrderDetails{}

// MessageOrderDetails struct for MessageOrderDetails
type MessageOrderDetails struct {
	PaymentConfiguration string `json:"payment_configuration"`
	ReferenceId *string `json:"reference_id,omitempty"`
	Currency string `json:"currency"`
	Tax string `json:"tax"`
	Expiration *MessageOrderDetailsExpiration `json:"expiration,omitempty"`
	Items []MessageOrderDetailsItemsInner `json:"items"`
	Discount *MessageOrderDetailsDiscount `json:"discount,omitempty"`
}

// NewMessageOrderDetails instantiates a new MessageOrderDetails object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMessageOrderDetails(paymentConfiguration string, currency string, tax string, items []MessageOrderDetailsItemsInner) *MessageOrderDetails {
	this := MessageOrderDetails{}
	this.PaymentConfiguration = paymentConfiguration
	this.Currency = currency
	this.Tax = tax
	this.Items = items
	return &this
}

// NewMessageOrderDetailsWithDefaults instantiates a new MessageOrderDetails object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMessageOrderDetailsWithDefaults() *MessageOrderDetails {
	this := MessageOrderDetails{}
	return &this
}

// GetPaymentConfiguration returns the PaymentConfiguration field value
func (o *MessageOrderDetails) GetPaymentConfiguration() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.PaymentConfiguration
}

// GetPaymentConfigurationOk returns a tuple with the PaymentConfiguration field value
// and a boolean to check if the value has been set.
func (o *MessageOrderDetails) GetPaymentConfigurationOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.PaymentConfiguration, true
}

// SetPaymentConfiguration sets field value
func (o *MessageOrderDetails) SetPaymentConfiguration(v string) {
	o.PaymentConfiguration = v
}

// GetReferenceId returns the ReferenceId field value if set, zero value otherwise.
func (o *MessageOrderDetails) GetReferenceId() string {
	if o == nil || IsNil(o.ReferenceId) {
		var ret string
		return ret
	}
	return *o.ReferenceId
}

// GetReferenceIdOk returns a tuple with the ReferenceId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageOrderDetails) GetReferenceIdOk() (*string, bool) {
	if o == nil || IsNil(o.ReferenceId) {
		return nil, false
	}
	return o.ReferenceId, true
}

// HasReferenceId returns a boolean if a field has been set.
func (o *MessageOrderDetails) HasReferenceId() bool {
	if o != nil && !IsNil(o.ReferenceId) {
		return true
	}

	return false
}

// SetReferenceId gets a reference to the given string and assigns it to the ReferenceId field.
func (o *MessageOrderDetails) SetReferenceId(v string) {
	o.ReferenceId = &v
}

// GetCurrency returns the Currency field value
func (o *MessageOrderDetails) GetCurrency() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Currency
}

// GetCurrencyOk returns a tuple with the Currency field value
// and a boolean to check if the value has been set.
func (o *MessageOrderDetails) GetCurrencyOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Currency, true
}

// SetCurrency sets field value
func (o *MessageOrderDetails) SetCurrency(v string) {
	o.Currency = v
}

// GetTax returns the Tax field value
func (o *MessageOrderDetails) GetTax() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Tax
}

// GetTaxOk returns a tuple with the Tax field value
// and a boolean to check if the value has been set.
func (o *MessageOrderDetails) GetTaxOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Tax, true
}

// SetTax sets field value
func (o *MessageOrderDetails) SetTax(v string) {
	o.Tax = v
}

// GetExpiration returns the Expiration field value if set, zero value otherwise.
func (o *MessageOrderDetails) GetExpiration() MessageOrderDetailsExpiration {
	if o == nil || IsNil(o.Expiration) {
		var ret MessageOrderDetailsExpiration
		return ret
	}
	return *o.Expiration
}

// GetExpirationOk returns a tuple with the Expiration field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageOrderDetails) GetExpirationOk() (*MessageOrderDetailsExpiration, bool) {
	if o == nil || IsNil(o.Expiration) {
		return nil, false
	}
	return o.Expiration, true
}

// HasExpiration returns a boolean if a field has been set.
func (o *MessageOrderDetails) HasExpiration() bool {
	if o != nil && !IsNil(o.Expiration) {
		return true
	}

	return false
}

// SetExpiration gets a reference to the given MessageOrderDetailsExpiration and assigns it to the Expiration field.
func (o *MessageOrderDetails) SetExpiration(v MessageOrderDetailsExpiration) {
	o.Expiration = &v
}

// GetItems returns the Items field value
func (o *MessageOrderDetails) GetItems() []MessageOrderDetailsItemsInner {
	if o == nil {
		var ret []MessageOrderDetailsItemsInner
		return ret
	}

	return o.Items
}

// GetItemsOk returns a tuple with the Items field value
// and a boolean to check if the value has been set.
func (o *MessageOrderDetails) GetItemsOk() ([]MessageOrderDetailsItemsInner, bool) {
	if o == nil {
		return nil, false
	}
	return o.Items, true
}

// SetItems sets field value
func (o *MessageOrderDetails) SetItems(v []MessageOrderDetailsItemsInner) {
	o.Items = v
}

// GetDiscount returns the Discount field value if set, zero value otherwise.
func (o *MessageOrderDetails) GetDiscount() MessageOrderDetailsDiscount {
	if o == nil || IsNil(o.Discount) {
		var ret MessageOrderDetailsDiscount
		return ret
	}
	return *o.Discount
}

// GetDiscountOk returns a tuple with the Discount field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageOrderDetails) GetDiscountOk() (*MessageOrderDetailsDiscount, bool) {
	if o == nil || IsNil(o.Discount) {
		return nil, false
	}
	return o.Discount, true
}

// HasDiscount returns a boolean if a field has been set.
func (o *MessageOrderDetails) HasDiscount() bool {
	if o != nil && !IsNil(o.Discount) {
		return true
	}

	return false
}

// SetDiscount gets a reference to the given MessageOrderDetailsDiscount and assigns it to the Discount field.
func (o *MessageOrderDetails) SetDiscount(v MessageOrderDetailsDiscount) {
	o.Discount = &v
}

func (o MessageOrderDetails) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MessageOrderDetails) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["payment_configuration"] = o.PaymentConfiguration
	if !IsNil(o.ReferenceId) {
		toSerialize["reference_id"] = o.ReferenceId
	}
	toSerialize["currency"] = o.Currency
	toSerialize["tax"] = o.Tax
	if !IsNil(o.Expiration) {
		toSerialize["expiration"] = o.Expiration
	}
	toSerialize["items"] = o.Items
	if !IsNil(o.Discount) {
		toSerialize["discount"] = o.Discount
	}
	return toSerialize, nil
}

type NullableMessageOrderDetails struct {
	value *MessageOrderDetails
	isSet bool
}

func (v NullableMessageOrderDetails) Get() *MessageOrderDetails {
	return v.value
}

func (v *NullableMessageOrderDetails) Set(val *MessageOrderDetails) {
	v.value = val
	v.isSet = true
}

func (v NullableMessageOrderDetails) IsSet() bool {
	return v.isSet
}

func (v *NullableMessageOrderDetails) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMessageOrderDetails(val *MessageOrderDetails) *NullableMessageOrderDetails {
	return &NullableMessageOrderDetails{value: val, isSet: true}
}

func (v NullableMessageOrderDetails) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMessageOrderDetails) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


